'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _sourceMapSupport2 = require('source-map-support');

var _wdioLogger = require('wdio-logger');

var _wdioLogger2 = _interopRequireDefault(_wdioLogger);

var _wdioConfig = require('wdio-config');

var _monad = require('./monad');

var _monad2 = _interopRequireDefault(_monad);

var _request = require('./request');

var _request2 = _interopRequireDefault(_request);

var _constants = require('./constants');

var _utils = require('./utils');

var _webdriver = require('../protocol/webdriver.json');

var _webdriver2 = _interopRequireDefault(_webdriver);

var _jsonwp = require('../protocol/jsonwp.json');

var _jsonwp2 = _interopRequireDefault(_jsonwp);

var _mjsonwp = require('../protocol/mjsonwp.json');

var _mjsonwp2 = _interopRequireDefault(_mjsonwp);

var _appium = require('../protocol/appium.json');

var _appium2 = _interopRequireDefault(_appium);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _sourceMapSupport2.install)();

var WebDriver = function () {
    function WebDriver() {
        (0, _classCallCheck3.default)(this, WebDriver);
    }

    (0, _createClass3.default)(WebDriver, null, [{
        key: 'newSession',
        value: function () {
            var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
                var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
                var modifier = arguments[1];
                var proto = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
                var commandWrapper = arguments[3];
                var params, sessionRequest, response, prototype, monad;
                return _regenerator2.default.wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                params = (0, _wdioConfig.validateConfig)(_constants.DEFAULTS, options);

                                _wdioLogger2.default.setLevel('webdriver', params.logLevel);

                                sessionRequest = new _request2.default('POST', '/session', {
                                    capabilities: params.capabilities, // W3C compliant
                                    desiredCapabilities: params.capabilities // JSONWP compliant
                                });
                                _context.next = 5;
                                return sessionRequest.makeRequest(params);

                            case 5:
                                response = _context.sent;

                                params.capabilities = response.value.capabilities || response.value;
                                params.isW3C = Boolean(response.value.capabilities);

                                prototype = (0, _assign2.default)(WebDriver.getPrototype(params.isW3C), proto);
                                monad = (0, _monad2.default)(params, modifier, prototype);
                                return _context.abrupt('return', monad(response.value.sessionId || response.sessionId, commandWrapper));

                            case 11:
                            case 'end':
                                return _context.stop();
                        }
                    }
                }, _callee, this);
            }));

            function newSession() {
                return _ref.apply(this, arguments);
            }

            return newSession;
        }()
    }, {
        key: 'WebDriver',
        get: function get() {
            return WebDriver;
        }
    }, {
        key: 'DEFAULTS',
        get: function get() {
            return _constants.DEFAULTS;
        }
    }, {
        key: 'WebDriverProtocol',
        get: function get() {
            return _webdriver2.default;
        }
    }, {
        key: 'JsonWProtocol',
        get: function get() {
            return _jsonwp2.default;
        }
    }, {
        key: 'MJsonWProtocol',
        get: function get() {
            return _mjsonwp2.default;
        }
    }, {
        key: 'AppiumProtocol',
        get: function get() {
            return _appium2.default;
        }
    }, {
        key: 'webdriverMonad',
        get: function get() {
            return _monad2.default;
        }
    }, {
        key: 'getPrototype',
        get: function get() {
            return _utils.getPrototype;
        }
    }]);
    return WebDriver;
}();

exports.default = WebDriver;
module.exports = exports['default'];